#! /usr/bin/python
# -*- coding: utf-8 -*-
import unifier
from importer.Argument import SemanticRole
from semantics.models import FrameOpinion
import semantics.models
from unifier.models import UnifiedFrameArgument, UnifiedFrame, UnifiedFrame2SlowalFrameMapping, \
    UnifiedFrameArgumentSlowalFrameMapping, Frame


class UnifiedFrameImport:

    @classmethod
    def storeAndGetRoleType(self, type):
        role_type = semantics.models.RoleType.objects.get(type=type)
        return role_type

    @classmethod
    def storeUnifiedFrameArgument(cls, tree, unifiedFrame, argumentIdsMapping):
        id = tree._attrs['id']
        attribute = None
        semantic_roles = []

        for subtree in tree._children:
            if subtree._name == 'semantic_role':
                role_type = subtree._attrs['type']
            elif subtree._name == 'roles':
                for value in subtree._children:
                    role = value._attrs['name']
                    semantic_role = SemanticRole(role, attribute)
                    semantic_roles.append(semantic_role)
            else:
                print(subtree._attrs['name'])
                raise UnknownError()

        role_type_obj = UnifiedFrameImport.storeAndGetRoleType(role_type)
        role_type_obj.save()
        argument = UnifiedFrameArgument(role_type=role_type_obj,
                                        unified_frame=unifiedFrame)
        argument.save()

        argumentIdsMapping[id] = argument.pk

        argument.proposed_roles.set([])
        argument.role = None
        for semantic_role in semantic_roles:
            semantic_roles_obj = semantic_role.store()
            semantic_roles_obj.save()
            print('Assign semantic_role {} to argument id {}'.format(semantic_roles_obj.role.role, argument.pk))
            argument.proposed_roles.add(semantic_roles_obj)

        argument.save()

    @classmethod
    def storeSlowalFrame(cls, tree, unifiedFrame, argumentIdsMapping):
        slowal_frame_id = tree._attrs['id']

        frames = Frame.objects.filter(pk=slowal_frame_id)
        if frames.exists():
            unifiedFrame2SlowalFrameMapping = UnifiedFrame2SlowalFrameMapping(unified_frame=unifiedFrame,
                                                                            slowal_frame_id=slowal_frame_id)
            unifiedFrame2SlowalFrameMapping.save()

            for subtree in tree._children:
                if subtree._name == 'argument_connections':
                    for subsubtree in subtree._children:
                        if subsubtree._name == 'argument_connection':
                            unifier_argument_id = subsubtree._attrs['unifier_argument_id']
                            slowal_id = subsubtree._attrs['slowal_id']
                            unifiedFrameArgumentSlowalFrameMapping = UnifiedFrameArgumentSlowalFrameMapping(unified_frame_mapping=unifiedFrame2SlowalFrameMapping,
                                                                                                          unified_agrument_id=argumentIdsMapping[unifier_argument_id],
                                                                                                          slowal_agrument_id=slowal_id)
                            unifiedFrameArgumentSlowalFrameMapping.save()
        else:
            print('Slowal frame do not exists in database: {}', slowal_frame_id)

    @classmethod
    def storeUnifiedFrame(cls, frame_tree):

        unifiedFrame = UnifiedFrame()
        unifiedFrame.save()

        argumentIdsMapping = {}
        for node in frame_tree._children:
            if node._name == 'argument':
                UnifiedFrameImport.storeUnifiedFrameArgument(node, unifiedFrame, argumentIdsMapping)

        for node in frame_tree._children:
            if node._name == 'connections':
                for subnode in node._children:
                    if subnode._name == 'slowal_frame':
                        UnifiedFrameImport.storeSlowalFrame(subnode, unifiedFrame, argumentIdsMapping)

        unifiedFrame.arguments_count = len(argumentIdsMapping)
        unifiedFrame.update_sloval_frame_count()
        unifiedFrame.save()

        return unifiedFrame.pk

